package org.mb.components;

import java.util.Hashtable;

import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Item;

import org.mb.components.interfaces.MBComponentContainer;
import org.mb.micromvc.model.AbstractModel;

public class MBForm extends Form implements MBComponentContainer {

	private Hashtable components;

	private AbstractModel object;

	public MBForm(String arg0) {
		super(arg0);
		components = new Hashtable();
	}

	/**
	 * Object can be String, Image or Item
	 *
	 * (non-Javadoc)
	 * @see org.mb.components.interfaces.MBComponentContainer#addComponent(java.lang.Object, java.lang.String)
	 */
	public void addComponent(Object component, String name) {
		if(component instanceof Item){
			append((Item)component);
		} else if(component instanceof String){
			append((String)component);
		} else if(component instanceof Image){
			append((Image)component);
		}

		components.put(name, component);
	}

	public Object getComponent(String name) {
		return components.get(name);
	}

	/**
	 * unsupported for now
	 */
	public void removeComponent(String name) {
		// TODO
		components.remove(name);
		deleteAll();
	}

	public AbstractModel getObject() {
		return object;
	}

	public void setObject(AbstractModel object) {
		this.object = object;
	}

}
