package org.mb.components.interfaces;

import org.mb.micromvc.model.AbstractModel;


/**
 * Container interface witch holds all components in form
 *
 * @author gubriansky
 *
 */
public interface MBComponentContainer {

	/**
	 * returns component by name
	 *
	 * @param name
	 * @return
	 */
	public Object getComponent(String name);

	/**
	 * add new component to screen
	 *
	 * @param component
	 * @param name
	 */
	public void addComponent(Object component, String name);

	/**
	 * removes component from screen
	 *
	 * @param name
	 */
	public void removeComponent(String name);

	public AbstractModel getObject();

	public void setObject(AbstractModel object);

}
