package org.mb.micromvc.controller;

import javax.microedition.lcdui.Screen;

import org.mb.session.Conversation;

/**
 * Default controller class the highest parrent of all controllers
 *
 * @author gubriansky
 *
 */
public abstract class AbstractController {

	/**
	 * default selector
	 */
	protected static final String DEFAULT_SELECTOR = "view";

	/**
	 * conversation
	 */
	protected Conversation c;

	/**
	 * controllerMapping
	 */
	private String controllerMapping = null;

	/**
	 * @return
	 */
	protected abstract Object constructForm();

	/**
	 * @return
	 */
	protected abstract Object getForm();

	/**
	 * conversation setter
	 *
	 * @param newVal
	 */
	public void setConversation(Conversation newVal) {
		c = newVal;
	}

	/**
	 * conversation getter
	 *
	 * @return
	 */
	public Conversation getConversation() {
		return c;
	}

	/**
	 * @return
	 */
	protected String getControllerMapping() {
		return controllerMapping;
	}

	/**
	 * @param controller
	 */
	public void setControllerMapping(String controller) {
		this.controllerMapping = controller;
	}

	/**
	 * returns new instance of cancel controller from conversation
	 *
	 * @return
	 */
	protected Object getBackController() {
		if (c != null) {
			Object back = null;
			try {
				back = Class.forName(c.getCancelController().getName())
						.newInstance();
			} catch (IllegalAccessException e) {
				e.printStackTrace();
			} catch (InstantiationException e) {
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}
			if (back != null) {
				return back;
			}
		}
		return null;
	}

}
