package org.mb.session;

import javax.microedition.lcdui.Display;
import javax.microedition.midlet.MIDlet;

import org.mb.micromvc.AppRunner;
import org.mb.micromvc.controller.AbstractController;
import org.mb.micromvc.controller.base.BaseController;

/**
 * Main MIDlet class
 *
 * @author gubriansky
 *
 */
public abstract class MicroMIDlet extends MIDlet {

	/**
	 * actual controller
	 */
	protected AbstractController controller;

	/**
	 * current display
	 */
	protected Display d;

	/**
	 * conversation object
	 */
	protected Conversation conversation;

	protected AppRunner runner;

	/**
	 * method gets actual controller from conversation and render its content to
	 * display
	 */
	public void refreshDisplay() {
		if (controller.getConversation().getController() != null) {
			controller = (BaseController) conversation.getController();
			d = ((BaseController) controller).renderView(this);
		}
	}

	/**
	 * actual controller getter
	 *
	 * @return BaseController
	 */
	protected AbstractController getController() {
		return controller;
	}

	/**
	 * controller setter
	 *
	 * @param bc(BaseController)
	 */
	protected void setController(BaseController bc) {
		controller = bc;
	}

	/**
	 * method starts application
	 *
	 * run conversation, sets main controller and add it to conversation
	 *
	 * @param contr
	 */
	protected void start(BaseController contr){
		runner = new AppRunner();
		runner.start();
		conversation = runner.getConversation();
		conversation.setAttribute(Conversation.MIDLET, this);
		controller = contr;
		controller.setConversation(conversation);
		controller.getConversation().setAttribute(Conversation.CONTROLLER,
				controller);
	}

}
